//+------------------------------------------------------------------+
//|                         EasyOrder settings.mq4                   |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2011, sangmane.And pimped by Ramy3"
#property  link      "sangmane@forexfactory.com" 
#import "EasyOrder.dll"
int EasyOrder(int hwnd);
//---- input parameters
extern string StealthMode="Stealth";
extern bool        SteathMode =true;

extern string TradeSettingsHours1="Before & Between & After";
extern string      BeforeBetween= "07:00";
extern string      BetweenAfter= "10:30";

extern string TradeSettingsStops="Stop Loss-1 Before-2 Between-3 After";
extern double      StopLossPips=6.5;
extern double      StopLossPips1=7.5;
extern double      StopLossPips2=8.0;

extern string TradeSettingsTakeProfit="Take Profit-1 Before-2 Between-3 After";
extern double      TakeProfitPips=6.5;
extern double      TakeProfitPips1=7.5;
extern double      TakeProfitPips2=8.0;

extern string LineColorsStyles="Line Colors & Styles";
extern color       StoplossColor=Lime;
extern color       TakeprofitColor=Lime;
extern int         Width=0;
extern int         Style =3;
extern int         Text_Size =10;
extern string      TextFont = "Arial"; 

extern string TradeSettings6 = "Box corner / not working";
extern int	       BoxCorner = 0;// Choose which corner to place headlines 0=Upper Left, 1=Upper Right, 2=lower left , 3=lower right

#define MODE_INIT 3
#define MODE_DEINIT 2
#define MODE_NORMAL 1

int         pip, Digt, cnt;
double         TPp, SLp;

int EasyOrder(int hwnd);
string obj;
int i, ticket;
//---------------------------------------------------------------------------------------------
int init(){

   initEA1();
   initEA2();
}
int initEA1(){
   OrderManager(MODE_INIT);    
   int hwnd = WindowHandle(Symbol(),0);
	ObjectSet("EASYORDER", OBJPROP_CORNER, BoxCorner);
	int ret = EasyOrder(hwnd);
   return(0);
}
int deinit(){
   if ( SteathMode ==false)
   deinitEA1();
   else
   if ( SteathMode ==true) 
   deinitEA2();
}
int deinitEA1(){
   OrderManager(MODE_DEINIT);  
    return(0);
}   
//+------------------------------------------------------------------+
int start(){
   if ( SteathMode ==false)
   start_EA1();
   else
   if ( SteathMode ==true) 
   start_EA2();
}
int start_EA1(){
   OrderManager(MODE_NORMAL);
{ 
      if(Close[0]>10)  {pip=1000; Digt=3;}  else
      if(Close[0]<10)  {pip=100000; Digt=5;}
      
      if(OrdersTotal()!=0)
         {
         for(cnt=0; cnt<OrdersTotal(); cnt++)
            {
            OrderSelect(cnt,SELECT_BY_POS);
            
  double T1 = StrToTime(TimeToStr(TimeLocal(),TIME_DATE) + " " + BeforeBetween + ":00");
  double T2 = StrToTime(TimeToStr(TimeLocal(),TIME_DATE) + " " + BetweenAfter + ":00");
             
    //--------------Take Profit--------------------------------
           if(OrderTakeProfit()==0 && TakeProfitPips && TakeProfitPips1 && TakeProfitPips2 !=0) {
                  if(OrderType()==OP_BUY && OrderSymbol()==Symbol())
                  if ((TimeLocal()<=T1))
                    { TPp = OrderOpenPrice()+TakeProfitPips/pip*10;}
                  else  
                  if ((TimeLocal()>=T1)&&(TimeLocal()<=T2))
                     {TPp = OrderOpenPrice()+TakeProfitPips1/pip*10;}
                  else   
                  if ((TimeLocal()>=T2)) 
                    {TPp = OrderOpenPrice()+TakeProfitPips2/pip*10;}     
     //--------------------------------------------------------------------------//                 
                  if(OrderType()==OP_SELL && OrderSymbol()==Symbol())              
                  if ((TimeLocal()<=T1))        
                    {TPp = OrderOpenPrice()-TakeProfitPips/pip*10;}
                  else          
                  if ((TimeLocal()>=T1)&&(TimeLocal()<=T2))
                    {TPp = OrderOpenPrice()-TakeProfitPips1/pip*10;}
                  else           
                  if ((TimeLocal()>=T2))    
                     {TPp = OrderOpenPrice()-TakeProfitPips2/pip*10;}                               
                  } else TPp = OrderTakeProfit();
               
     //--------------Stop Loss-------------------------------------------

            if(OrderStopLoss()==0 && StopLossPips && StopLossPips1 && StopLossPips2 !=0)
               { if(OrderType()==OP_BUY && OrderSymbol()==Symbol()) 
                 if ((TimeLocal()<=T1))     
                    {SLp = OrderOpenPrice()-StopLossPips/pip*10;}
                 else  
                 if ((TimeLocal()>=T1)&&(TimeLocal()<=T2))  
                    {SLp = OrderOpenPrice()-StopLossPips1/pip*10;}
                 else 
                 if ((TimeLocal()>=T2))   
                     {SLp = OrderOpenPrice()-StopLossPips2/pip*10;} 
     //-----------------------------------------------------------------                
             if(OrderType()==OP_SELL && OrderSymbol()==Symbol())  
                 if ((TimeLocal()<=T1))                  
                     {SLp = OrderOpenPrice()+StopLossPips/pip*10;}
                 else 
                 if ((TimeLocal()>=T1)&&(TimeLocal()<=T2)) 
                     {SLp = OrderOpenPrice()+StopLossPips1/pip*10;}
                 else
                     if ((TimeLocal()>=T2)) 
                     {SLp = OrderOpenPrice()+StopLossPips2/pip*10;}
                 } else SLp = OrderStopLoss();

    //---------------Modify Order--------------------------
            if (OrderType()==OP_BUY || OrderType()==OP_SELL)   
            OrderModify(OrderTicket(),OrderOpenPrice(),SLp,TPp,0);               
    //-----------------------------------------------------        
      } 
    }        
  }
}  
void DeleteGFX(int tickets[]){
   for(int i=ArraySize(tickets)-1;i>=0;i--){
      ObjectDelete(tickets[i]+"-sl");
      ObjectDelete(tickets[i]+"-open");
      ObjectDelete(tickets[i]+"-tp");   
      ObjectsDeleteAll(OBJ_HLINE);

   }
}
void UpdateGFX(int tickets[]){
   for(int i=ArraySize(tickets)-1;i>=0;i--){
      OrderSelect(tickets[i],SELECT_BY_TICKET);
      ObjectCreate(tickets[i]+"-sl",OBJ_HLINE,0,0,OrderStopLoss());
      ObjectSet(tickets[i]+"-sl",OBJPROP_WIDTH,Width);
      ObjectSet(tickets[i]+"-sl",OBJPROP_PRICE1,OrderStopLoss());
      ObjectSet(tickets[i]+"-sl",OBJPROP_COLOR,StoplossColor);    
      ObjectSet(tickets[i]+"-sl",OBJPROP_STYLE,Style);

      
      ObjectCreate(tickets[i]+"-tp",OBJ_HLINE,0,0,OrderTakeProfit());
      ObjectSet(tickets[i]+"-tp",OBJPROP_WIDTH,Width);
      ObjectSet(tickets[i]+"-tp",OBJPROP_COLOR,TakeprofitColor);   
      ObjectSet(tickets[i]+"-tp",OBJPROP_STYLE,Style);
      ObjectSet(tickets[i]+"-tp",OBJPROP_PRICE1,OrderTakeProfit());
   }   
}
void RecalcByGFX(int &tickets[],double &sl[], double &tp[]){
   for(int i=ArraySize(tickets)-1;i>=0;i--){
      OrderSelect(tickets[i],SELECT_BY_TICKET);
      double gfx.tp,gfx.sl;
      gfx.tp=NormalizeDouble(ObjectGet(tickets[i]+"-tp",OBJPROP_PRICE1),Digits);
      if(gfx.tp!=OrderTakeProfit()){
         if(gfx.tp!=tp[i]){
            if(OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),NormalizeDouble(gfx.tp,Digits),0,CLR_NONE)){
               tp[i]=gfx.tp;
               ObjectSet(tickets[i]+"-tp_l",OBJPROP_TIME1,OrderOpenTime());
               ObjectSet(tickets[i]+"-tp_l",OBJPROP_PRICE1,gfx.tp);
               ObjectSet(tickets[i]+"-tp_l",OBJPROP_COLOR,TakeprofitColor);  
              }
         }else{
            ObjectSet(tickets[i]+"-tp",OBJPROP_PRICE1,OrderTakeProfit());
            ObjectSet(tickets[i]+"-tp_l",OBJPROP_TIME1,OrderOpenTime());
            ObjectSet(tickets[i]+"-tp_l",OBJPROP_PRICE1,OrderTakeProfit());
            ObjectSet(tickets[i]+"-tp_l",OBJPROP_COLOR,TakeprofitColor);          
            tp[i]=gfx.tp;               
         }
      }
      gfx.sl=NormalizeDouble(ObjectGet(tickets[i]+"-sl",OBJPROP_PRICE1),Digits);
      if(gfx.sl!=OrderStopLoss()){
         if(gfx.sl!=sl[i]){
            if(OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(gfx.sl,Digits),OrderTakeProfit(),0,CLR_NONE)){
               sl[i]=gfx.sl;
               ObjectSet(tickets[i]+"-sl_l",OBJPROP_TIME1,OrderOpenTime());
               ObjectSet(tickets[i]+"-sl_l",OBJPROP_PRICE1,gfx.sl);
               ObjectSet(tickets[i]+"-sl_l",OBJPROP_COLOR,StoplossColor);          
            }
         }else{
            ObjectSet(tickets[i]+"-sl",OBJPROP_PRICE1,OrderStopLoss());
            ObjectSet(tickets[i]+"-sl_l",OBJPROP_TIME1,OrderOpenTime());
            ObjectSet(tickets[i]+"-sl_l",OBJPROP_PRICE1,OrderStopLoss());
            ObjectSet(tickets[i]+"-sl_l",OBJPROP_COLOR,StoplossColor);        
            sl[i]=gfx.sl;               
         }
      }
   }   
}
void OrderManager(int mode){
   static int tickets[];
   static double tp[];
   static double sl[];
   if(mode==MODE_DEINIT){
      DeleteGFX(tickets);
   }else{
      if(mode==MODE_INIT){
         ArrayResize(tickets,0);
      }
      int i=0;
      int OpenOrdersOnSymbol=0;
      for(i=OrdersTotal()-1;i>=0;i--){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol()){
            OpenOrdersOnSymbol++;
         }
      }
      if(OpenOrdersOnSymbol!=ArraySize(tickets)){
         DeleteGFX(tickets);
         ArrayResize(tickets,OpenOrdersOnSymbol);
         ArrayResize(tp,OpenOrdersOnSymbol);
         ArrayResize(tp,OpenOrdersOnSymbol);
         int j=0;
         for(i=OrdersTotal()-1;i>=0;i--){
            OrderSelect(i,SELECT_BY_POS);
            if(OrderSymbol()==Symbol()){
               tickets[j]=OrderTicket();
               sl[j]=OrderStopLoss();
               tp[j]=OrderStopLoss();
               j++;
            }
         }
         UpdateGFX(tickets);
      }else{
         RecalcByGFX(tickets,tp,sl);
      }
   }
}
int initEA2() {
   start(); 
   ObjectDelete("BuyStopLoss");
   ObjectDelete("BuyTakeProfit");
   ObjectDelete("SellStopLoss");
   ObjectDelete("SellTakeProfit");
   ObjectDelete("BuyStopLossText");
   ObjectDelete("BuyTakeProfitText");
   ObjectDelete("SellStopLossText");
   ObjectDelete("SellTakeProfitText");
   return (0); 
}
int deinitEA2() {
   if (ObjectGet("BuyStopLoss", OBJPROP_PRICE1) > 0.0) ObjectDelete("BuyStopLoss");
   if (ObjectGet("BuyTakeProfit", OBJPROP_PRICE1) > 0.0) ObjectDelete("BuyTakeProfit");
   if (ObjectGet("SellStopLoss", OBJPROP_PRICE1) > 0.0) ObjectDelete("SellStopLoss");
   if (ObjectGet("SellTakeProfit", OBJPROP_PRICE1) > 0.0) ObjectDelete("SellTakeProfit");
   if (ObjectGet("BuyStopLossText", OBJPROP_PRICE1) > 0.0) ObjectDelete("BuyStopLossText");
   if (ObjectGet("BuyTakeProfitText", OBJPROP_PRICE1) > 0.0) ObjectDelete("BuyTakeProfitText");
   if (ObjectGet("SellStopLossText", OBJPROP_PRICE1) > 0.0) ObjectDelete("SellStopLossText");
   if (ObjectGet("SellTakeProfitText", OBJPROP_PRICE1) > 0.0) ObjectDelete("SellTakeProfitText");
   ObjectsDeleteAll(OBJ_HLINE);   
   return (0);   
}
int start_EA2()
{
   double T1 = StrToTime(TimeToStr(TimeLocal(),TIME_DATE) + " " + BeforeBetween + ":00");
   double T2 = StrToTime(TimeToStr(TimeLocal(),TIME_DATE) + " " + BetweenAfter + ":00");   

	double pip=Point;
	if(Digits==3 || Digits==5) pip = 10*Point;
   RefreshRates();
   if (TOOC() > 0) {
      for (int l_pos_0 = 0; l_pos_0 < OrdersTotal(); l_pos_0++) {
         if (OrderSelect(l_pos_0, SELECT_BY_POS)) {
            if (OrderSymbol() == Symbol()) {
                 
                  if ((TimeLocal()<=T1))
                  if (OrderType() == OP_BUY) {
                  ObjectCreate("BuyStopLoss", OBJ_HLINE, 0, 0, OrderOpenPrice() - StopLossPips * pip);
                  ObjectSet("BuyStopLoss", OBJPROP_COLOR, StoplossColor);
                  ObjectSet("BuyStopLoss", OBJPROP_STYLE, Style);
                  ObjectSet("BuyStopLoss",OBJPROP_WIDTH,Width);
                  if (ObjectGet("BuyStopLoss", OBJPROP_PRICE1) > 0.0) {
                     ObjectCreate("BuyStopLossText", OBJ_TEXT, 0, 0, 0);
                     ObjectSet("BuyStopLossText", OBJPROP_TIME1, Time[0]);
                     ObjectSet("BuyStopLossText", OBJPROP_PRICE1, ObjectGet("BuyStopLoss", OBJPROP_PRICE1));
                     ObjectSetText("BuyStopLossText", "                                  BuyStopLoss", Text_Size, TextFont, StoplossColor);
                  }
                  ObjectCreate("BuyTakeProfit", OBJ_HLINE, 0, 0, OrderOpenPrice() + TakeProfitPips * pip);
                  ObjectSet("BuyTakeProfit", OBJPROP_COLOR, TakeprofitColor);
                  ObjectSet("BuyTakeProfit", OBJPROP_STYLE, Style);
                  ObjectSet("BuyTakeProfit",OBJPROP_WIDTH,Width);
                  if (ObjectGet("BuyTakeProfit", OBJPROP_PRICE1) > 0.0) {
                     ObjectCreate("BuyTakeProfitText", OBJ_TEXT, 0, 0, 0);
                     ObjectSet("BuyTakeProfitText", OBJPROP_TIME1, Time[0]);
                     ObjectSet("BuyTakeProfitText", OBJPROP_PRICE1, ObjectGet("BuyTakeProfit", OBJPROP_PRICE1));
                     ObjectSetText("BuyTakeProfitText", "                                  BuyTakeProfit", Text_Size, TextFont, TakeprofitColor);
                  }
                  if (Close[0] <= ObjectGet("BuyStopLoss", OBJPROP_PRICE1) || Close[0] >= ObjectGet("BuyTakeProfit", OBJPROP_PRICE1)) {
                     OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 25, White);
                     if (ObjectGet("BuyStopLoss", OBJPROP_PRICE1) > 0.0) ObjectDelete("BuyStopLoss");
                     if (ObjectGet("BuyTakeProfit", OBJPROP_PRICE1) > 0.0) ObjectDelete("BuyTakeProfit");
                     if (ObjectGet("BuyStopLossText", OBJPROP_PRICE1) > 0.0) ObjectDelete("BuyStopLossText");
                     if (ObjectGet("BuyTakeProfitText", OBJPROP_PRICE1) > 0.0) ObjectDelete("BuyTakeProfitText");
                  }
                  }
                  if (OrderType() == OP_SELL) {
                  ObjectCreate("SellStopLoss", OBJ_HLINE, 0, 0, OrderOpenPrice() + StopLossPips * pip);
                  ObjectSet("SellStopLoss", OBJPROP_COLOR, StoplossColor);
                  ObjectSet("SellStopLoss", OBJPROP_STYLE, Style);
                  ObjectSet("SellStopLoss",OBJPROP_WIDTH,Width);
                  if (ObjectGet("SellStopLoss", OBJPROP_PRICE1) > 0.0) {
                     ObjectCreate("SellStopLossText", OBJ_TEXT, 0, 0, 0);
                     ObjectSet("SellStopLossText", OBJPROP_TIME1, Time[0]);
                     ObjectSet("SellStopLossText", OBJPROP_PRICE1, ObjectGet("SellStopLoss", OBJPROP_PRICE1));
                     ObjectSetText("SellStopLossText", "                                  SellStopLoss", Text_Size, TextFont, StoplossColor);
                  }
                  ObjectCreate("SellTakeProfit", OBJ_HLINE, 0, 0, OrderOpenPrice() - TakeProfitPips * pip);
                  ObjectSet("SellTakeProfit", OBJPROP_COLOR, TakeprofitColor);
                  ObjectSet("SellTakeProfit", OBJPROP_STYLE, Style);
                  ObjectSet("SellTakeProfit",OBJPROP_WIDTH,Width);
                  if (ObjectGet("SellTakeProfit", OBJPROP_PRICE1) > 0.0) {
                     ObjectCreate("SellTakeProfitText", OBJ_TEXT, 0, 0, 0);
                     ObjectSet("SellTakeProfitText", OBJPROP_TIME1, Time[0]);
                     ObjectSet("SellTakeProfitText", OBJPROP_PRICE1, ObjectGet("SellTakeProfit", OBJPROP_PRICE1));
                     ObjectSetText("SellTakeProfitText", "                                  SellTakeProfit", Text_Size, TextFont, TakeprofitColor);
                  }
                  if (Close[0] >= ObjectGet("SellStopLoss", OBJPROP_PRICE1) || Close[0] <= ObjectGet("SellTakeProfit", OBJPROP_PRICE1)) {
                     OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 25, White);
                     if (ObjectGet("SellStopLoss", OBJPROP_PRICE1) > 0.0) ObjectDelete("SellStopLoss");
                     if (ObjectGet("SellTakeProfit", OBJPROP_PRICE1) > 0.0) ObjectDelete("SellTakeProfit");
                     if (ObjectGet("SellStopLossText", OBJPROP_PRICE1) > 0.0) ObjectDelete("SellStopLossText");
                     if (ObjectGet("SellTakeProfitText", OBJPROP_PRICE1) > 0.0) ObjectDelete("SellTakeProfitText");        
                  }        
                  }  else
                  if ((TimeLocal()>=T1)&&(TimeLocal()<=T2)) 
                  if (OrderType() == OP_BUY) {
                  ObjectCreate("BuyStopLoss", OBJ_HLINE, 0, 0, OrderOpenPrice() - StopLossPips1 * pip);
                  ObjectSet("BuyStopLoss", OBJPROP_COLOR, StoplossColor);
                  ObjectSet("BuyStopLoss", OBJPROP_STYLE, Style);
                  ObjectSet("BuyStopLoss", OBJPROP_WIDTH,Width);
                  if (ObjectGet("BuyStopLoss", OBJPROP_PRICE1) > 0.0) {
                     ObjectCreate("BuyStopLossText", OBJ_TEXT, 0, 0, 0);
                     ObjectSet("BuyStopLossText", OBJPROP_TIME1, Time[0]);
                     ObjectSet("BuyStopLossText", OBJPROP_PRICE1, ObjectGet("BuyStopLoss", OBJPROP_PRICE1));
                     ObjectSetText("BuyStopLossText", "                                  BuyStopLoss", 10, TextFont, StoplossColor);
                  }
                  ObjectCreate("BuyTakeProfit", OBJ_HLINE, 0, 0, OrderOpenPrice() + TakeProfitPips1 * pip);
                  ObjectSet("BuyTakeProfit", OBJPROP_COLOR, TakeprofitColor);
                  ObjectSet("BuyTakeProfit", OBJPROP_STYLE, Style);
                  ObjectSet("BuyTakeProfit", OBJPROP_WIDTH,Width);
                  if (ObjectGet("BuyTakeProfit", OBJPROP_PRICE1) > 0.0) {
                     ObjectCreate("BuyTakeProfitText", OBJ_TEXT, 0, 0, 0);
                     ObjectSet("BuyTakeProfitText", OBJPROP_TIME1, Time[0]);
                     ObjectSet("BuyTakeProfitText", OBJPROP_PRICE1, ObjectGet("BuyTakeProfit", OBJPROP_PRICE1));
                     ObjectSetText("BuyTakeProfitText", "                                  BuyTakeProfit", Text_Size, TextFont, TakeprofitColor);
                  }
                  if (Close[0] <= ObjectGet("BuyStopLoss", OBJPROP_PRICE1) || Close[0] >= ObjectGet("BuyTakeProfit", OBJPROP_PRICE1)) {
                     OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 25, White);
                     if (ObjectGet("BuyStopLoss", OBJPROP_PRICE1) > 0.0) ObjectDelete("BuyStopLoss");
                     if (ObjectGet("BuyTakeProfit", OBJPROP_PRICE1) > 0.0) ObjectDelete("BuyTakeProfit");
                     if (ObjectGet("BuyStopLossText", OBJPROP_PRICE1) > 0.0) ObjectDelete("BuyStopLossText");
                     if (ObjectGet("BuyTakeProfitText", OBJPROP_PRICE1) > 0.0) ObjectDelete("BuyTakeProfitText");
                  }
                  }
                  if (OrderType() == OP_SELL) {
                  ObjectCreate("SellStopLoss", OBJ_HLINE, 0, 0, OrderOpenPrice() + StopLossPips1 * pip);
                  ObjectSet("SellStopLoss", OBJPROP_COLOR, StoplossColor);
                  ObjectSet("SellStopLoss", OBJPROP_STYLE, Style);
                  ObjectSet("SellStopLoss", OBJPROP_WIDTH,Width);
                  if (ObjectGet("SellStopLoss", OBJPROP_PRICE1) > 0.0) {
                     ObjectCreate("SellStopLossText", OBJ_TEXT, 0, 0, 0);
                     ObjectSet("SellStopLossText", OBJPROP_TIME1, Time[0]);
                     ObjectSet("SellStopLossText", OBJPROP_PRICE1, ObjectGet("SellStopLoss", OBJPROP_PRICE1));
                     ObjectSetText("SellStopLossText", "                                  SellStopLoss", Text_Size, TextFont, StoplossColor);
                  }
                  ObjectCreate("SellTakeProfit", OBJ_HLINE, 0, 0, OrderOpenPrice() - TakeProfitPips1 * pip);
                  ObjectSet("SellTakeProfit", OBJPROP_COLOR, TakeprofitColor);
                  ObjectSet("SellTakeProfit", OBJPROP_STYLE, Style);
                  ObjectSet("SellTakeProfit", OBJPROP_WIDTH,Width);
                  if (ObjectGet("SellTakeProfit", OBJPROP_PRICE1) > 0.0) {
                     ObjectCreate("SellTakeProfitText", OBJ_TEXT, 0, 0, 0);
                     ObjectSet("SellTakeProfitText", OBJPROP_TIME1, Time[0]);
                     ObjectSet("SellTakeProfitText", OBJPROP_PRICE1, ObjectGet("SellTakeProfit", OBJPROP_PRICE1));
                     ObjectSetText("SellTakeProfitText", "                                  SellTakeProfit", Text_Size, TextFont, TakeprofitColor);
                  }
                  if (Close[0] >= ObjectGet("SellStopLoss", OBJPROP_PRICE1) || Close[0] <= ObjectGet("SellTakeProfit", OBJPROP_PRICE1)) {
                     OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 25, White);
                     if (ObjectGet("SellStopLoss", OBJPROP_PRICE1) > 0.0) ObjectDelete("SellStopLoss");
                     if (ObjectGet("SellTakeProfit", OBJPROP_PRICE1) > 0.0) ObjectDelete("SellTakeProfit");
                     if (ObjectGet("SellStopLossText", OBJPROP_PRICE1) > 0.0) ObjectDelete("SellStopLossText");
                     if (ObjectGet("SellTakeProfitText", OBJPROP_PRICE1) > 0.0) ObjectDelete("SellTakeProfitText");
                  }
                  } else
                  if ((TimeLocal()>=T2)) 
                  if (OrderType() == OP_BUY) {
                  ObjectCreate("BuyStopLoss", OBJ_HLINE, 0, 0, OrderOpenPrice() - StopLossPips2 * pip);
                  ObjectSet("BuyStopLoss", OBJPROP_COLOR, StoplossColor);
                  ObjectSet("BuyStopLoss", OBJPROP_STYLE, Style);
                  ObjectSet("BuyStopLoss", OBJPROP_WIDTH,Width);
                  if (ObjectGet("BuyStopLoss", OBJPROP_PRICE1) > 0.0) {
                     ObjectCreate("BuyStopLossText", OBJ_TEXT, 0, 0, 0);
                     ObjectSet("BuyStopLossText", OBJPROP_TIME1, Time[0]);
                     ObjectSet("BuyStopLossText", OBJPROP_PRICE1, ObjectGet("BuyStopLoss", OBJPROP_PRICE1));
                     ObjectSetText("BuyStopLossText", "                                  BuyStopLoss", Text_Size, TextFont, StoplossColor);
                  }
                  ObjectCreate("BuyTakeProfit", OBJ_HLINE, 0, 0, OrderOpenPrice() + TakeProfitPips2 * pip);
                  ObjectSet("BuyTakeProfit", OBJPROP_COLOR, TakeprofitColor);
                  ObjectSet("BuyTakeProfit", OBJPROP_STYLE, Style);
                  ObjectSet("BuyTakeProfit", OBJPROP_WIDTH,Width);
                  if (ObjectGet("BuyTakeProfit", OBJPROP_PRICE1) > 0.0) {
                     ObjectCreate("BuyTakeProfitText", OBJ_TEXT, 0, 0, 0);
                     ObjectSet("BuyTakeProfitText", OBJPROP_TIME1, Time[0]);
                     ObjectSet("BuyTakeProfitText", OBJPROP_PRICE1, ObjectGet("BuyTakeProfit", OBJPROP_PRICE1));
                     ObjectSetText("BuyTakeProfitText", "                                  BuyTakeProfit", Text_Size, TextFont, TakeprofitColor);
                  }
                  if (Close[0] <= ObjectGet("BuyStopLoss", OBJPROP_PRICE1) || Close[0] >= ObjectGet("BuyTakeProfit", OBJPROP_PRICE1)) {
                     OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 25, White);
                     if (ObjectGet("BuyStopLoss", OBJPROP_PRICE1) > 0.0) ObjectDelete("BuyStopLoss");
                     if (ObjectGet("BuyTakeProfit", OBJPROP_PRICE1) > 0.0) ObjectDelete("BuyTakeProfit");
                     if (ObjectGet("BuyStopLossText", OBJPROP_PRICE1) > 0.0) ObjectDelete("BuyStopLossText");
                     if (ObjectGet("BuyTakeProfitText", OBJPROP_PRICE1) > 0.0) ObjectDelete("BuyTakeProfitText");
                  }
                  }
                  if (OrderType() == OP_SELL) {
                  ObjectCreate("SellStopLoss", OBJ_HLINE, 0, 0, OrderOpenPrice() + StopLossPips2 * pip);
                  ObjectSet("SellStopLoss", OBJPROP_COLOR, StoplossColor);
                  ObjectSet("SellStopLoss", OBJPROP_STYLE, Style);
                  ObjectSet("SellStopLoss", OBJPROP_WIDTH,Width);
                  if (ObjectGet("SellStopLoss", OBJPROP_PRICE1) > 0.0) {
                     ObjectCreate("SellStopLossText", OBJ_TEXT, 0, 0, 0);
                     ObjectSet("SellStopLossText", OBJPROP_TIME1, Time[0]);
                     ObjectSet("SellStopLossText", OBJPROP_PRICE1, ObjectGet("SellStopLoss", OBJPROP_PRICE1));
                     ObjectSetText("SellStopLossText", "                                  SellStopLoss", Text_Size, TextFont, StoplossColor);
                  }
                  ObjectCreate("SellTakeProfit", OBJ_HLINE, 0, 0, OrderOpenPrice() - TakeProfitPips2 * pip);
                  ObjectSet("SellTakeProfit", OBJPROP_COLOR, TakeprofitColor);
                  ObjectSet("SellTakeProfit", OBJPROP_STYLE, Style);
                  ObjectSet("SellTakeProfit", OBJPROP_WIDTH,Width);
                  if (ObjectGet("SellTakeProfit", OBJPROP_PRICE1) > 0.0) {
                     ObjectCreate("SellTakeProfitText", OBJ_TEXT, 0, 0, 0);
                     ObjectSet("SellTakeProfitText", OBJPROP_TIME1, Time[0]);
                     ObjectSet("SellTakeProfitText", OBJPROP_PRICE1, ObjectGet("SellTakeProfit", OBJPROP_PRICE1));
                     ObjectSetText("SellTakeProfitText", "                                  SellTakeProfit", Text_Size, TextFont, TakeprofitColor);
                  }
                  if (Close[0] >= ObjectGet("SellStopLoss", OBJPROP_PRICE1) || Close[0] <= ObjectGet("SellTakeProfit", OBJPROP_PRICE1)) {
                     OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 25, White);
                     if (ObjectGet("SellStopLoss", OBJPROP_PRICE1) > 0.0) ObjectDelete("SellStopLoss");
                     if (ObjectGet("SellTakeProfit", OBJPROP_PRICE1) > 0.0) ObjectDelete("SellTakeProfit");
                     if (ObjectGet("SellStopLossText", OBJPROP_PRICE1) > 0.0) ObjectDelete("SellStopLossText");
                     if (ObjectGet("SellTakeProfitText", OBJPROP_PRICE1) > 0.0) ObjectDelete("SellTakeProfitText");                     
                  }
               }
            }
         }
      }
   }   
}  
int TOOC() {
   int li_ret_0;
   for (int l_pos_4 = 0; l_pos_4 < OrdersTotal(); l_pos_4++) {
      if (OrderSelect(l_pos_4, SELECT_BY_POS))
         if (OrderSymbol() == Symbol()) li_ret_0++;
   }
   return (li_ret_0);   
}